#include <gtk/gtk.h>
#include <libosso.h>
#include <stdlib.h>
#include <hildon-widgets/hildon-input-mode-hint.h>

#include "map_widget.h"
#include "ui.h"

const gchar * TEST_MAP_DBUS_SERVICE = "org.cityguide.mapdownloader";
const gchar * TEST_MAP_DBUS_OBJECT_PATH = "/org/cityguide/mapdownloader";
const gchar * TEST_MAP_DBUS_INTERFACE = "org.cityguide.mapdownloader";


int main(int argc, char **argv)
{
    gint maptileloader;
    
    /* if Maptile-loader not already running -> start 
	Maptile-loader */

    maptileloader = system("pidof maptile-loader");
    if ( maptileloader != 0)
        system("run-standalone.sh maptile-loader &");


    GtkWidget *window;

    osso_context_t *_osso = NULL;

    Adata *adata;
    adata = g_new0(Adata, 1);
 
  
    gtk_init(&argc, &argv);

    _osso = osso_initialize ( TEST_MAP_DBUS_SERVICE, "0.1", TRUE, NULL );
    g_assert ( _osso );

    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);


    /* fill Adata struct */   
    adata->window = window;
    adata->osso = _osso;

    create_ui(adata);

    gtk_widget_show_all(window);
    gtk_main();

    return 0;
}
