#include <gtk/gtk.h>
#include <libosso.h>
#include <stdlib.h>
#include <glib.h>
#include <hildon-widgets/hildon-input-mode-hint.h>

#include "map_widget.h"
#include "ui.h"
#include "map_download.h"


static GtkWidget *label_coord_clicked ;
static MapPoint *last_clicked;
static MW_cb *nw_corner;
static MW_cb *se_corner;


GtkWidget *buttons[16];

GPtrArray *corner_nw_cb_array = NULL;
GPtrArray *corner_se_cb_array = NULL;

static MapPoint *se_draw;

static MapPoint *nw_draw;

void draw_nw(GtkWidget *dmap, gpointer data)
{
    /* This is own callback. Every time map expose this function will execute.
    
       This cb will draw icon to coordinates defined below.*/
    map_widget_draw_icon_to_coords(dmap,nw_draw,NW);

} 

void draw_se(GtkWidget *dmap, gpointer data)
{
    /* This is own callback. Every time map expose this function will execute.
    
       This cb will draw icon to coordinates defined below.*/
    map_widget_draw_icon_to_coords(dmap,se_draw,SE);


} 


void screen_clicked(GtkWidget *dmap, gint x, gint y, gfloat lat, gfloat lon)
{
    printf("\n\n x/y: %d/%d ja lat/lon %f/%f\n",x,y,lat,lon);
    gtk_label_set_text(GTK_LABEL(label_coord_clicked),g_strdup_printf("lat:%f , lon: %f",lat,lon));

    last_clicked->latitude = lat;
    last_clicked->longitude = lon;

    MapPoint *center;
    center = g_new0(MapPoint, 1);
    center->latitude = lat;
    center->longitude =lon;

    map_widget_set_current_location(dmap,center);
 

}
static guint map_widget_convert_zoom(guint zoom)
{
       gint ret = 17 - zoom;
       if ( ret < 0 )
               return DEFAULT_ZOOM;
       return ret;
}
static
void button_press(GtkWidget * widget, gpointer data)
{
    Adata *adata = (Adata*)data;

    const gchar* buffer;
    gfloat start_lat;
    gfloat start_lon;
    gfloat end_lat;
    gfloat end_lon;
    const gchar *maptype;
    gboolean zoom_levels[16];
    gint i;
    gint dl = 0;

    for (i=0; i<17;i++)
    {

    printf("taulukkoon:i:%d :%d\n",i,map_widget_convert_zoom(i));
    
    dl = map_widget_convert_zoom(i);
    zoom_levels[dl] = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(buttons[i]));
    printf("napissa %d\n\n",zoom_levels[dl]);
    }
    zoom_levels[0]= 0;

    maptype = gtk_entry_get_text (GTK_ENTRY (adata->entry_maptype) );


    buffer = gtk_entry_get_text(GTK_ENTRY(adata->entry_lat_start));
    start_lat = atof(buffer);

    buffer = gtk_entry_get_text(GTK_ENTRY(adata->entry_lon_start));
    start_lon = atof(buffer);

    buffer = gtk_entry_get_text(GTK_ENTRY(adata->entry_lat_end));
    end_lat =  atof(buffer);

    buffer = gtk_entry_get_text(GTK_ENTRY(adata->entry_lon_end));
    end_lon =  atof(buffer);

    printf(" downloadin area %f/%f to %f/%f \n%s\n",start_lat, start_lon, end_lat, end_lon,maptype);

    mapman_by_area(start_lat, start_lon, end_lat, end_lon,data, maptype, zoom_levels);

}
static
void add_nw(GtkWidget * widget, gpointer data)
{
    Adata *adata = (Adata*)data;
    gtk_entry_set_text(GTK_ENTRY(adata->entry_lat_start),g_strdup_printf("%f",last_clicked->latitude));
    gtk_entry_set_text(GTK_ENTRY(adata->entry_lon_start),g_strdup_printf("%f",last_clicked->longitude));


    nw_draw->latitude = last_clicked->latitude;
    nw_draw->longitude = last_clicked->longitude;

    map_widget_draw_icon_to_coords(adata->dmap,nw_draw,SER_NW);

}
static
void add_se(GtkWidget * widget, gpointer data)
{
    Adata *adata = (Adata*)data;

    gtk_entry_set_text(GTK_ENTRY(adata->entry_lat_end),g_strdup_printf("%f",last_clicked->latitude));
    gtk_entry_set_text(GTK_ENTRY(adata->entry_lon_end),g_strdup_printf("%f",last_clicked->longitude));

    se_draw->latitude = last_clicked->latitude;
    se_draw->longitude = last_clicked->longitude;

    map_widget_draw_icon_to_coords(adata->dmap,se_draw,SER_SE);

}
void zoom_in(GtkWidget * widget, gpointer data)
{
    guint zoom;
    Adata *adata= (Adata*)data;


    zoom = map_widget_get_current_zoom_level(adata->dmap) + 1;

    if (zoom >0 && zoom <17)
    {
    	map_widget_set_zoom(adata->dmap, zoom);
	gtk_label_set_text(GTK_LABEL(adata->label_curr_zoom),g_strdup_printf("%d",zoom));
    }



}
void zoom_out(GtkWidget * widget, gpointer data)
{
    guint zoom;
    Adata *adata= (Adata*)data;

    zoom = map_widget_get_current_zoom_level(adata->dmap) - 1;

    if (zoom >0 && zoom <17)
    {
    	map_widget_set_zoom(adata->dmap, zoom);
	gtk_label_set_text(GTK_LABEL(adata->label_curr_zoom),g_strdup_printf("%d",zoom));
    }



}
GtkWidget* create_zoom_level_boxes(Adata* adata)
{
    GtkWidget *vbox;
    GtkWidget *label;
    gint i;

    

    vbox = gtk_vbox_new(TRUE,0);


    label = gtk_label_new("Zoom");
    gtk_container_add(GTK_CONTAINER(vbox),label);

    for (i=0;i<17;i++)
    {

        buttons[i] = gtk_check_button_new_with_label(g_strdup_printf("%d",i));
        gtk_container_add(GTK_CONTAINER(vbox),buttons[i]);
    }



return vbox;
}


void create_ui(Adata *adata)
{

    GtkWidget *button;
    GtkWidget *label;
    GtkWidget *dmap;
    GtkWidget *table;
    GtkWidget *entry_maptype;

    /* start center point for map */
    MapPoint *center;
    center = g_new0(MapPoint, 1);
    center->latitude = 65.013;
    center->longitude = 25.509;


    last_clicked = g_new0(MapPoint, 1);
    last_clicked->latitude = 65.013;
    last_clicked->longitude = 25.509;


    table = gtk_table_new(10, 10, TRUE);
    adata->table = table;
    gtk_container_add(GTK_CONTAINER(adata->window), adata->table);
    g_signal_connect(adata->window, "destroy", G_CALLBACK(gtk_main_quit), NULL);

    dmap = map_widget_create();
    adata->dmap = dmap;
    gtk_table_attach_defaults(GTK_TABLE(adata->table), adata->dmap, 3, 9 ,1 ,9);

    map_widget_new_from_center_zoom_type(adata->dmap, center, 12.0,
					 MAP_ORIENTATION_NORTH,
					 "Google Street",adata->osso);

    label = gtk_label_new("Maptype:");
       gtk_table_attach_defaults(GTK_TABLE(adata->table), label, 0, 3 ,0, 1);

    entry_maptype = gtk_entry_new();
    adata->entry_maptype = entry_maptype;
       gtk_table_attach_defaults(GTK_TABLE(adata->table), adata->entry_maptype, 0, 3, 1, 2);
    gtk_entry_set_text (GTK_ENTRY (adata->entry_maptype),"Google Street" );

    label = gtk_label_new("North-West corner");
       gtk_table_attach_defaults(GTK_TABLE(adata->table), label, 0, 3 ,1, 2);

    label = gtk_label_new("Lat:");
       gtk_table_attach_defaults(GTK_TABLE(adata->table), label, 0, 1 ,2, 3);

    label = gtk_label_new("Lon:");
       gtk_table_attach_defaults(GTK_TABLE(adata->table), label, 0, 1 ,3, 4);

    adata->entry_lat_start = gtk_entry_new();
       gtk_table_attach_defaults(GTK_TABLE(adata->table), adata->entry_lat_start, 1, 3, 2, 3);
    gtk_editable_set_editable(GTK_EDITABLE(adata->entry_lat_start),FALSE);


    adata->entry_lon_start = gtk_entry_new();
       gtk_table_attach_defaults(GTK_TABLE(adata->table), adata->entry_lon_start, 1, 3, 3, 4);
    gtk_editable_set_editable(GTK_EDITABLE(adata->entry_lon_start),FALSE);



    label = gtk_label_new("South-East corner");
       gtk_table_attach_defaults(GTK_TABLE(adata->table), label, 0, 3 ,5, 6);

    label = gtk_label_new("Lat:");
       gtk_table_attach_defaults(GTK_TABLE(adata->table), label, 0, 1 ,6, 7);
 
    label = gtk_label_new("Lon:");
       gtk_table_attach_defaults(GTK_TABLE(adata->table), label, 0, 1 ,7, 8);

    adata->entry_lat_end = gtk_entry_new();
       gtk_table_attach_defaults(GTK_TABLE(adata->table), adata->entry_lat_end, 1, 3, 6, 7);
    gtk_editable_set_editable(GTK_EDITABLE(adata->entry_lat_end),FALSE);


    adata->entry_lon_end = gtk_entry_new();
       gtk_table_attach_defaults(GTK_TABLE(adata->table), adata->entry_lon_end, 1, 3, 7, 8);
    gtk_editable_set_editable(GTK_EDITABLE(adata->entry_lon_end),FALSE);

    button = gtk_button_new_with_label("download");
    gtk_table_attach_defaults(GTK_TABLE(adata->table), button,3, 6, 9, 10);
    g_signal_connect(G_OBJECT(button), "clicked",
		     G_CALLBACK(button_press), adata);

    button = gtk_button_new_with_label("Add NW");
    gtk_table_attach_defaults(GTK_TABLE(adata->table), button, 1, 3, 4, 5);
    g_signal_connect(G_OBJECT(button), "clicked",
		     G_CALLBACK(add_nw), adata);

    button = gtk_button_new_with_label("Add SE");
    gtk_table_attach_defaults(GTK_TABLE(adata->table), button, 1, 3, 8, 9 );
    g_signal_connect(G_OBJECT(button), "clicked",
		     G_CALLBACK(add_se), adata);


    button = gtk_button_new_with_label("-");
    gtk_table_attach_defaults(GTK_TABLE(adata->table), button, 6, 7, 9, 10 );
    g_signal_connect(G_OBJECT(button), "clicked",
		     G_CALLBACK(zoom_out), adata);

    adata->label_curr_zoom = gtk_label_new(g_strdup_printf("%d",map_widget_get_current_zoom_level (adata->dmap)));
       gtk_table_attach_defaults(GTK_TABLE(adata->table), adata->label_curr_zoom, 7, 8, 9, 10);

    button = gtk_button_new_with_label("+");
    gtk_table_attach_defaults(GTK_TABLE(adata->table), button, 8, 9, 9, 10 );
    g_signal_connect(G_OBJECT(button), "clicked",
		     G_CALLBACK(zoom_in), adata);




    label_coord_clicked = gtk_label_new("Click map to get coordinates");
       gtk_table_attach_defaults(GTK_TABLE(adata->table), label_coord_clicked, 4, 9, 0, 1);


    map_widget_set_screen_clicked_cb(adata->dmap, screen_clicked);

    se_corner = g_new0(MW_cb, 1);
    nw_corner = g_new0(MW_cb, 1);

    se_corner->cb_func_name = (mw_callback*)draw_se;
    se_corner->do_cb_func = TRUE;
    se_corner->data = NULL;

    nw_corner->cb_func_name = (mw_callback*)draw_nw;
    nw_corner->do_cb_func = TRUE;
    nw_corner->data = NULL;


    corner_nw_cb_array = g_ptr_array_new();
    corner_se_cb_array = g_ptr_array_new();

    g_ptr_array_add(corner_nw_cb_array, nw_corner);
    g_ptr_array_add(corner_se_cb_array, se_corner);

    map_widget_set_cb_func_array(adata->dmap, corner_nw_cb_array, 1);
    map_widget_set_cb_func_array(adata->dmap, corner_se_cb_array, 2);


    nw_draw = g_new0(MapPoint, 1);
    nw_draw->latitude = 0.0;
    nw_draw->longitude = 0.0;

    se_draw = g_new0(MapPoint, 1);
    se_draw->latitude = 0.0;
    se_draw->longitude = 0.0;

    gtk_table_attach_defaults(GTK_TABLE(adata->table), create_zoom_level_boxes(adata), 9, 10, 0, 10);

    gtk_widget_show_all(adata->table);

}

